﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Tree
{
    class MaxHeap<T> where T : IComparable
    {
        private List<T> heapList;

        private T Data { get; set; }
        public MaxHeap(T nd)
        {
            heapList = new List<T>();
            heapList.Add(nd);
        }

        public void Insert(T d)
        {
            heapList.Add(d);
            CheckHeap(heapList.Count - 1);
        }

        private void CheckHeap(int i)
        {
            if ((i <= 1) || (heapList[i].CompareTo(heapList[i / 2]) <= 0))
                return;
            else
            {
                T temp = heapList[i];
                heapList[i] = heapList[i / 2];
                heapList[i / 2] = temp;
                CheckHeap(i / 2);
            }

        }

        public T ExtractMax ()
        {
            T temp = heapList[1];
            heapList[1] = heapList[heapList.Count - 1];
            heapList.RemoveAt(heapList.Count - 1);
            BubbleDown(1);
            return temp;
        }
        private void Swap (int x , int y)
        {
            T temp = heapList[x];
            heapList[x] = heapList[y];
            heapList[y] = temp;
        }

        private void BubbleDown(int i)
        {
            if (i * 2 + 1 < heapList.Count )
            {
                if (heapList[i * 2].CompareTo(heapList[i * 2 + 1]) > 0)
                {
                    if (heapList[i].CompareTo(heapList[i * 2]) < 0)
                    {
                        Swap(i, i * 2);
                        BubbleDown(i * 2);
                    }
                }
                else
                {
                    if (heapList[i].CompareTo(heapList[i * 2 + 1]) < 0)
                    {
                        Swap(i, i * 2 + 1);
                        BubbleDown(i * 2 + 1);
                    }
                }
     
            }
            else if (i * 2 < heapList.Count )
            {
                if (heapList[i].CompareTo(heapList[i * 2]) < 0)
                    Swap(i, i * 2);
            }
        }

        public int Count => heapList.Count - 1;
        public T MaxData => heapList[1];

    }
}
