﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Tree
{
    class MidHeap<T> where T : IComparable
    {
        private T mid;
        private MinHeap<T> minHeap;
        private MaxHeap<T> maxHeap;
        public MidHeap(T d)
        {
            mid = d;
            minHeap = new MinHeap<T>(d);
            maxHeap = new MaxHeap<T>(d);
        }
        public T Insert(T d)
        {
            if (mid.CompareTo(d) < 0)
            {
                if (minHeap.Count > maxHeap.Count)
                    maxHeap.Insert(minHeap.ExtractMin());
                minHeap.Insert(d);
                mid = minHeap.MinData;
            }
            else
            {
                if (minHeap.Count < maxHeap.Count)
                    minHeap.Insert(maxHeap.ExtractMax());
                maxHeap.Insert(d);
                mid = maxHeap.MaxData;
            }

            if (minHeap.Count == maxHeap.Count) mid = minHeap.MinData;
            return mid;
        }

        public T MidData => mid;

        public void PrintAll()
        {
            Console.WriteLine("Count of Max Heap : " + maxHeap.Count.ToString());
            Console.WriteLine("Count of Min Heap : " + minHeap.Count.ToString());
            Console.WriteLine("Max Data : " + maxHeap.MaxData.ToString());
            Console.WriteLine("Min Data : " + minHeap.MinData.ToString());
        }
    }
}
